D2I_BASIC_CONSTRAINTS(3)

NAME
d2i_BASIC_CONSTRAINTS, i2d_BASIC_CONSTRAINTS, d2i_EXTENDED_KEY_USAGE, i2d_EXTENDED_KEY_USAGE - decode and encode X.509 key usage purposes

SYNOPSIS
#include <openssl/x509v3.h>
BASIC_CONSTRAINTS *
d2i_BASIC_CONSTRAINTS(BASIC_CONSTRAINTS **val_out, const unsigned char **der_in, long length);
int
i2d_BASIC_CONSTRAINTS(BASIC_CONSTRAINTS *val_in, unsigned char **der_out);
EXTENDED_KEY_USAGE *
d2i_EXTENDED_KEY_USAGE(EXTENDED_KEY_USAGE **val_out, const unsigned char **der_in, long length);
int
i2d_EXTENDED_KEY_USAGE(EXTENDED_KEY_USAGE *val_in, unsigned char **der_out);

DESCRIPTION
These functions decode and encode data structures describing the intended purposes that the key contained in an X.509 certificate is to be used for. For details about the semantics, examples, caveats, and bugs, see ASN1_item_d2i(3).

d2i_BASIC_CONSTRAINTS() and i2d_BASIC_CONSTRAINTS() decode and encode an ASN.1 BasicConstraints structure defined in RFC 5280 section 4.2.1.9.

d2i_EXTENDED_KEY_USAGE() and i2d_EXTENDED_KEY_USAGE() decode and encode an ASN.1 ExtKeyUsageSyntax structure defined in RFC 5280 section 4.2.1.12.

RETURN VALUES
d2i_BASIC_CONSTRAINTS() and d2i_EXTENDED_KEY_USAGE() return a BASIC_CONSTRAINTS or EXTENDED_KEY_USAGE object, respectively, or NULL if an error occurs.

i2d_BASIC_CONSTRAINTS() and i2d_EXTENDED_KEY_USAGE() return the number of bytes successfully encoded or a negative value if an error occurs.

SEE ALSO
ASN1_item_d2i(3), BASIC_CONSTRAINTS_new(3), EXTENDED_KEY_USAGE_new(3), X509_EXTENSION_new(3)

STANDARDS
RFC 5280: Internet X.509 Public Key Infrastructure Certificate and Certificate Revocation List (CRL) Profile